diff -urNp linux-2.6.32.24/drivers/ata/pata_optidma.c linux-2.6.32.24/drivers/ata/pata_optidma.c
--- linux-2.6.32.24/drivers/ata/pata_optidma.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_optidma.c	2010-09-04 15:54:51.000000000 -0400
@@ -337,7 +337,7 @@ static struct scsi_host_template optidma
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations optidma_port_ops = {
+static const struct ata_port_operations optidma_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= optidma_set_pio_mode,
@@ -346,7 +346,7 @@ static struct ata_port_operations optidm
 	.prereset	= optidma_pre_reset,
 };
 
-static struct ata_port_operations optiplus_port_ops = {
+static const struct ata_port_operations optiplus_port_ops = {
 	.inherits	= &optidma_port_ops,
 	.set_piomode	= optiplus_set_pio_mode,
 	.set_dmamode	= optiplus_set_dma_mode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_palmld.c linux-2.6.32.24/drivers/ata/pata_palmld.c
--- linux-2.6.32.24/drivers/ata/pata_palmld.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_palmld.c	2010-09-04 15:54:52.000000000 -0400
@@ -37,7 +37,7 @@ static struct scsi_host_template palmld_
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations palmld_port_ops = {
+static const struct ata_port_operations palmld_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.sff_data_xfer		= ata_sff_data_xfer_noirq,
 	.cable_detect		= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_pcmcia.c linux-2.6.32.24/drivers/ata/pata_pcmcia.c
--- linux-2.6.32.24/drivers/ata/pata_pcmcia.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_pcmcia.c	2010-09-04 15:54:52.000000000 -0400
@@ -162,14 +162,14 @@ static struct scsi_host_template pcmcia_
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pcmcia_port_ops = {
+static const struct ata_port_operations pcmcia_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.sff_data_xfer	= ata_sff_data_xfer_noirq,
 	.cable_detect	= ata_cable_40wire,
 	.set_mode	= pcmcia_set_mode,
 };
 
-static struct ata_port_operations pcmcia_8bit_port_ops = {
+static const struct ata_port_operations pcmcia_8bit_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.sff_data_xfer	= ata_data_xfer_8bit,
 	.cable_detect	= ata_cable_40wire,
@@ -256,7 +256,7 @@ static int pcmcia_init_one(struct pcmcia
 	unsigned long io_base, ctl_base;
 	void __iomem *io_addr, *ctl_addr;
 	int n_ports = 1;
-	struct ata_port_operations *ops = &pcmcia_port_ops;
+	const struct ata_port_operations *ops = &pcmcia_port_ops;
 
 	info = kzalloc(sizeof(*info), GFP_KERNEL);
 	if (info == NULL)
diff -urNp linux-2.6.32.24/drivers/ata/pata_pdc2027x.c linux-2.6.32.24/drivers/ata/pata_pdc2027x.c
--- linux-2.6.32.24/drivers/ata/pata_pdc2027x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_pdc2027x.c	2010-09-04 15:54:52.000000000 -0400
@@ -132,14 +132,14 @@ static struct scsi_host_template pdc2027
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pdc2027x_pata100_ops = {
+static const struct ata_port_operations pdc2027x_pata100_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.check_atapi_dma	= pdc2027x_check_atapi_dma,
 	.cable_detect		= pdc2027x_cable_detect,
 	.prereset		= pdc2027x_prereset,
 };
 
-static struct ata_port_operations pdc2027x_pata133_ops = {
+static const struct ata_port_operations pdc2027x_pata133_ops = {
 	.inherits		= &pdc2027x_pata100_ops,
 	.mode_filter		= pdc2027x_mode_filter,
 	.set_piomode		= pdc2027x_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_pdc202xx_old.c linux-2.6.32.24/drivers/ata/pata_pdc202xx_old.c
--- linux-2.6.32.24/drivers/ata/pata_pdc202xx_old.c	2010-09-26 17:26:05.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_pdc202xx_old.c	2010-09-28 18:21:13.000000000 -0400
@@ -274,7 +274,7 @@ static struct scsi_host_template pdc202x
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pdc2024x_port_ops = {
+static const struct ata_port_operations pdc2024x_port_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 
 	.cable_detect		= ata_cable_40wire,
@@ -284,7 +284,7 @@ static struct ata_port_operations pdc202
 	.sff_exec_command	= pdc202xx_exec_command,
 };
 
-static struct ata_port_operations pdc2026x_port_ops = {
+static const struct ata_port_operations pdc2026x_port_ops = {
 	.inherits		= &pdc2024x_port_ops,
 
 	.check_atapi_dma	= pdc2026x_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/pata_platform.c linux-2.6.32.24/drivers/ata/pata_platform.c
--- linux-2.6.32.24/drivers/ata/pata_platform.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_platform.c	2010-09-04 15:54:52.000000000 -0400
@@ -48,7 +48,7 @@ static struct scsi_host_template pata_pl
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pata_platform_port_ops = {
+static const struct ata_port_operations pata_platform_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.sff_data_xfer		= ata_sff_data_xfer_noirq,
 	.cable_detect		= ata_cable_unknown,
diff -urNp linux-2.6.32.24/drivers/ata/pata_qdi.c linux-2.6.32.24/drivers/ata/pata_qdi.c
--- linux-2.6.32.24/drivers/ata/pata_qdi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_qdi.c	2010-09-04 15:54:52.000000000 -0400
@@ -157,7 +157,7 @@ static struct scsi_host_template qdi_sht
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations qdi6500_port_ops = {
+static const struct ata_port_operations qdi6500_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.qc_issue	= qdi_qc_issue,
 	.sff_data_xfer	= qdi_data_xfer,
@@ -165,7 +165,7 @@ static struct ata_port_operations qdi650
 	.set_piomode	= qdi6500_set_piomode,
 };
 
-static struct ata_port_operations qdi6580_port_ops = {
+static const struct ata_port_operations qdi6580_port_ops = {
 	.inherits	= &qdi6500_port_ops,
 	.set_piomode	= qdi6580_set_piomode,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_radisys.c linux-2.6.32.24/drivers/ata/pata_radisys.c
--- linux-2.6.32.24/drivers/ata/pata_radisys.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_radisys.c	2010-09-04 15:54:52.000000000 -0400
@@ -187,7 +187,7 @@ static struct scsi_host_template radisys
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations radisys_pata_ops = {
+static const struct ata_port_operations radisys_pata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.qc_issue		= radisys_qc_issue,
 	.cable_detect		= ata_cable_unknown,
diff -urNp linux-2.6.32.24/drivers/ata/pata_rb532_cf.c linux-2.6.32.24/drivers/ata/pata_rb532_cf.c
--- linux-2.6.32.24/drivers/ata/pata_rb532_cf.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_rb532_cf.c	2010-09-04 15:54:52.000000000 -0400
@@ -68,7 +68,7 @@ static irqreturn_t rb532_pata_irq_handle
 	return IRQ_HANDLED;
 }
 
-static struct ata_port_operations rb532_pata_port_ops = {
+static const struct ata_port_operations rb532_pata_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.sff_data_xfer		= ata_sff_data_xfer32,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_rdc.c linux-2.6.32.24/drivers/ata/pata_rdc.c
--- linux-2.6.32.24/drivers/ata/pata_rdc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_rdc.c	2010-09-04 15:54:52.000000000 -0400
@@ -272,7 +272,7 @@ static void rdc_set_dmamode(struct ata_p
 	pci_write_config_byte(dev, 0x48, udma_enable);
 }
 
-static struct ata_port_operations rdc_pata_ops = {
+static const struct ata_port_operations rdc_pata_ops = {
 	.inherits		= &ata_bmdma32_port_ops,
 	.cable_detect		= rdc_pata_cable_detect,
 	.set_piomode		= rdc_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_rz1000.c linux-2.6.32.24/drivers/ata/pata_rz1000.c
--- linux-2.6.32.24/drivers/ata/pata_rz1000.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_rz1000.c	2010-09-04 15:54:52.000000000 -0400
@@ -54,7 +54,7 @@ static struct scsi_host_template rz1000_
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations rz1000_port_ops = {
+static const struct ata_port_operations rz1000_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_mode	= rz1000_set_mode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_sc1200.c linux-2.6.32.24/drivers/ata/pata_sc1200.c
--- linux-2.6.32.24/drivers/ata/pata_sc1200.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_sc1200.c	2010-09-04 15:54:52.000000000 -0400
@@ -207,7 +207,7 @@ static struct scsi_host_template sc1200_
 	.sg_tablesize	= LIBATA_DUMB_MAX_PRD,
 };
 
-static struct ata_port_operations sc1200_port_ops = {
+static const struct ata_port_operations sc1200_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.qc_prep 	= ata_sff_dumb_qc_prep,
 	.qc_issue	= sc1200_qc_issue,
diff -urNp linux-2.6.32.24/drivers/ata/pata_scc.c linux-2.6.32.24/drivers/ata/pata_scc.c
--- linux-2.6.32.24/drivers/ata/pata_scc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_scc.c	2010-09-04 15:54:52.000000000 -0400
@@ -965,7 +965,7 @@ static struct scsi_host_template scc_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations scc_pata_ops = {
+static const struct ata_port_operations scc_pata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 
 	.set_piomode		= scc_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_sch.c linux-2.6.32.24/drivers/ata/pata_sch.c
--- linux-2.6.32.24/drivers/ata/pata_sch.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_sch.c	2010-09-04 15:54:52.000000000 -0400
@@ -75,7 +75,7 @@ static struct scsi_host_template sch_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations sch_pata_ops = {
+static const struct ata_port_operations sch_pata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= ata_cable_unknown,
 	.set_piomode		= sch_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_serverworks.c linux-2.6.32.24/drivers/ata/pata_serverworks.c
--- linux-2.6.32.24/drivers/ata/pata_serverworks.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_serverworks.c	2010-09-04 15:54:52.000000000 -0400
@@ -299,7 +299,7 @@ static struct scsi_host_template serverw
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations serverworks_osb4_port_ops = {
+static const struct ata_port_operations serverworks_osb4_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= serverworks_cable_detect,
 	.mode_filter	= serverworks_osb4_filter,
@@ -307,7 +307,7 @@ static struct ata_port_operations server
 	.set_dmamode	= serverworks_set_dmamode,
 };
 
-static struct ata_port_operations serverworks_csb_port_ops = {
+static const struct ata_port_operations serverworks_csb_port_ops = {
 	.inherits	= &serverworks_osb4_port_ops,
 	.mode_filter	= serverworks_csb_filter,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_sil680.c linux-2.6.32.24/drivers/ata/pata_sil680.c
--- linux-2.6.32.24/drivers/ata/pata_sil680.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_sil680.c	2010-09-04 15:54:52.000000000 -0400
@@ -194,7 +194,7 @@ static struct scsi_host_template sil680_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations sil680_port_ops = {
+static const struct ata_port_operations sil680_port_ops = {
 	.inherits	= &ata_bmdma32_port_ops,
 	.cable_detect	= sil680_cable_detect,
 	.set_piomode	= sil680_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_sis.c linux-2.6.32.24/drivers/ata/pata_sis.c
--- linux-2.6.32.24/drivers/ata/pata_sis.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_sis.c	2010-09-04 15:54:52.000000000 -0400
@@ -503,47 +503,47 @@ static struct scsi_host_template sis_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations sis_133_for_sata_ops = {
+static const struct ata_port_operations sis_133_for_sata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.set_piomode		= sis_133_set_piomode,
 	.set_dmamode		= sis_133_set_dmamode,
 	.cable_detect		= sis_133_cable_detect,
 };
 
-static struct ata_port_operations sis_base_ops = {
+static const struct ata_port_operations sis_base_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.prereset		= sis_pre_reset,
 };
 
-static struct ata_port_operations sis_133_ops = {
+static const struct ata_port_operations sis_133_ops = {
 	.inherits		= &sis_base_ops,
 	.set_piomode		= sis_133_set_piomode,
 	.set_dmamode		= sis_133_set_dmamode,
 	.cable_detect		= sis_133_cable_detect,
 };
 
-static struct ata_port_operations sis_133_early_ops = {
+static const struct ata_port_operations sis_133_early_ops = {
 	.inherits		= &sis_base_ops,
 	.set_piomode		= sis_100_set_piomode,
 	.set_dmamode		= sis_133_early_set_dmamode,
 	.cable_detect		= sis_66_cable_detect,
 };
 
-static struct ata_port_operations sis_100_ops = {
+static const struct ata_port_operations sis_100_ops = {
 	.inherits		= &sis_base_ops,
 	.set_piomode		= sis_100_set_piomode,
 	.set_dmamode		= sis_100_set_dmamode,
 	.cable_detect		= sis_66_cable_detect,
 };
 
-static struct ata_port_operations sis_66_ops = {
+static const struct ata_port_operations sis_66_ops = {
 	.inherits		= &sis_base_ops,
 	.set_piomode		= sis_old_set_piomode,
 	.set_dmamode		= sis_66_set_dmamode,
 	.cable_detect		= sis_66_cable_detect,
 };
 
-static struct ata_port_operations sis_old_ops = {
+static const struct ata_port_operations sis_old_ops = {
 	.inherits		= &sis_base_ops,
 	.set_piomode		= sis_old_set_piomode,
 	.set_dmamode		= sis_old_set_dmamode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_sl82c105.c linux-2.6.32.24/drivers/ata/pata_sl82c105.c
--- linux-2.6.32.24/drivers/ata/pata_sl82c105.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_sl82c105.c	2010-09-04 15:54:52.000000000 -0400
@@ -231,7 +231,7 @@ static struct scsi_host_template sl82c10
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations sl82c105_port_ops = {
+static const struct ata_port_operations sl82c105_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.qc_defer	= sl82c105_qc_defer,
 	.bmdma_start 	= sl82c105_bmdma_start,
diff -urNp linux-2.6.32.24/drivers/ata/pata_triflex.c linux-2.6.32.24/drivers/ata/pata_triflex.c
--- linux-2.6.32.24/drivers/ata/pata_triflex.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_triflex.c	2010-09-04 15:54:52.000000000 -0400
@@ -178,7 +178,7 @@ static struct scsi_host_template triflex
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations triflex_port_ops = {
+static const struct ata_port_operations triflex_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.bmdma_start 	= triflex_bmdma_start,
 	.bmdma_stop	= triflex_bmdma_stop,
diff -urNp linux-2.6.32.24/drivers/ata/pata_via.c linux-2.6.32.24/drivers/ata/pata_via.c
--- linux-2.6.32.24/drivers/ata/pata_via.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_via.c	2010-09-04 15:54:52.000000000 -0400
@@ -419,7 +419,7 @@ static struct scsi_host_template via_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations via_port_ops = {
+static const struct ata_port_operations via_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= via_cable_detect,
 	.set_piomode	= via_set_piomode,
@@ -429,7 +429,7 @@ static struct ata_port_operations via_po
 	.port_start	= via_port_start,
 };
 
-static struct ata_port_operations via_port_ops_noirq = {
+static const struct ata_port_operations via_port_ops_noirq = {
 	.inherits	= &via_port_ops,
 	.sff_data_xfer	= ata_sff_data_xfer_noirq,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_winbond.c linux-2.6.32.24/drivers/ata/pata_winbond.c
--- linux-2.6.32.24/drivers/ata/pata_winbond.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_winbond.c	2010-09-04 15:54:52.000000000 -0400
@@ -125,7 +125,7 @@ static struct scsi_host_template winbond
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations winbond_port_ops = {
+static const struct ata_port_operations winbond_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.sff_data_xfer	= winbond_data_xfer,
 	.cable_detect	= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pdc_adma.c linux-2.6.32.24/drivers/ata/pdc_adma.c
--- linux-2.6.32.24/drivers/ata/pdc_adma.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pdc_adma.c	2010-09-04 15:54:52.000000000 -0400
@@ -145,7 +145,7 @@ static struct scsi_host_template adma_at
 	.dma_boundary		= ADMA_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations adma_ata_ops = {
+static const struct ata_port_operations adma_ata_ops = {
 	.inherits		= &ata_sff_port_ops,
 
 	.lost_interrupt		= ATA_OP_NULL,
diff -urNp linux-2.6.32.24/drivers/ata/sata_fsl.c linux-2.6.32.24/drivers/ata/sata_fsl.c
--- linux-2.6.32.24/drivers/ata/sata_fsl.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_fsl.c	2010-09-04 15:54:52.000000000 -0400
@@ -1258,7 +1258,7 @@ static struct scsi_host_template sata_fs
 	.dma_boundary = ATA_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations sata_fsl_ops = {
+static const struct ata_port_operations sata_fsl_ops = {
 	.inherits		= &sata_pmp_port_ops,
 
 	.qc_defer = ata_std_qc_defer,
diff -urNp linux-2.6.32.24/drivers/ata/sata_inic162x.c linux-2.6.32.24/drivers/ata/sata_inic162x.c
--- linux-2.6.32.24/drivers/ata/sata_inic162x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_inic162x.c	2010-09-04 15:54:52.000000000 -0400
@@ -721,7 +721,7 @@ static int inic_port_start(struct ata_po
 	return 0;
 }
 
-static struct ata_port_operations inic_port_ops = {
+static const struct ata_port_operations inic_port_ops = {
 	.inherits		= &sata_port_ops,
 
 	.check_atapi_dma	= inic_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/sata_mv.c linux-2.6.32.24/drivers/ata/sata_mv.c
--- linux-2.6.32.24/drivers/ata/sata_mv.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_mv.c	2010-09-20 17:27:14.000000000 -0400
@@ -656,7 +656,7 @@ static struct scsi_host_template mv6_sht
 	.dma_boundary		= MV_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations mv5_ops = {
+static const struct ata_port_operations mv5_ops = {
 	.inherits		= &ata_sff_port_ops,
 
 	.lost_interrupt		= ATA_OP_NULL,
@@ -678,7 +678,7 @@ static struct ata_port_operations mv5_op
 	.port_stop		= mv_port_stop,
 };
 
-static struct ata_port_operations mv6_ops = {
+static const struct ata_port_operations mv6_ops = {
 	.inherits		= &mv5_ops,
 	.dev_config             = mv6_dev_config,
 	.scr_read		= mv_scr_read,
@@ -698,7 +698,7 @@ static struct ata_port_operations mv6_op
 	.bmdma_status		= mv_bmdma_status,
 };
 
-static struct ata_port_operations mv_iie_ops = {
+static const struct ata_port_operations mv_iie_ops = {
 	.inherits		= &mv6_ops,
 	.dev_config		= ATA_OP_NULL,
 	.qc_prep		= mv_qc_prep_iie,
diff -urNp linux-2.6.32.24/drivers/ata/sata_nv.c linux-2.6.32.24/drivers/ata/sata_nv.c
--- linux-2.6.32.24/drivers/ata/sata_nv.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_nv.c	2010-09-04 15:54:52.000000000 -0400
@@ -464,7 +464,7 @@ static struct scsi_host_template nv_swnc
  * cases.  Define nv_hardreset() which only kicks in for post-boot
  * probing and use it for all variants.
  */
-static struct ata_port_operations nv_generic_ops = {
+static const struct ata_port_operations nv_generic_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.lost_interrupt		= ATA_OP_NULL,
 	.scr_read		= nv_scr_read,
@@ -472,20 +472,20 @@ static struct ata_port_operations nv_gen
 	.hardreset		= nv_hardreset,
 };
 
-static struct ata_port_operations nv_nf2_ops = {
+static const struct ata_port_operations nv_nf2_ops = {
 	.inherits		= &nv_generic_ops,
 	.freeze			= nv_nf2_freeze,
 	.thaw			= nv_nf2_thaw,
 };
 
-static struct ata_port_operations nv_ck804_ops = {
+static const struct ata_port_operations nv_ck804_ops = {
 	.inherits		= &nv_generic_ops,
 	.freeze			= nv_ck804_freeze,
 	.thaw			= nv_ck804_thaw,
 	.host_stop		= nv_ck804_host_stop,
 };
 
-static struct ata_port_operations nv_adma_ops = {
+static const struct ata_port_operations nv_adma_ops = {
 	.inherits		= &nv_ck804_ops,
 
 	.check_atapi_dma	= nv_adma_check_atapi_dma,
@@ -509,7 +509,7 @@ static struct ata_port_operations nv_adm
 	.host_stop		= nv_adma_host_stop,
 };
 
-static struct ata_port_operations nv_swncq_ops = {
+static const struct ata_port_operations nv_swncq_ops = {
 	.inherits		= &nv_generic_ops,
 
 	.qc_defer		= ata_std_qc_defer,
diff -urNp linux-2.6.32.24/drivers/ata/sata_promise.c linux-2.6.32.24/drivers/ata/sata_promise.c
--- linux-2.6.32.24/drivers/ata/sata_promise.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_promise.c	2010-09-04 15:54:52.000000000 -0400
@@ -195,7 +195,7 @@ static const struct ata_port_operations 
 	.error_handler		= pdc_error_handler,
 };
 
-static struct ata_port_operations pdc_sata_ops = {
+static const struct ata_port_operations pdc_sata_ops = {
 	.inherits		= &pdc_common_ops,
 	.cable_detect		= pdc_sata_cable_detect,
 	.freeze			= pdc_sata_freeze,
@@ -208,14 +208,14 @@ static struct ata_port_operations pdc_sa
 
 /* First-generation chips need a more restrictive ->check_atapi_dma op,
    and ->freeze/thaw that ignore the hotplug controls. */
-static struct ata_port_operations pdc_old_sata_ops = {
+static const struct ata_port_operations pdc_old_sata_ops = {
 	.inherits		= &pdc_sata_ops,
 	.freeze			= pdc_freeze,
 	.thaw			= pdc_thaw,
 	.check_atapi_dma	= pdc_old_sata_check_atapi_dma,
 };
 
-static struct ata_port_operations pdc_pata_ops = {
+static const struct ata_port_operations pdc_pata_ops = {
 	.inherits		= &pdc_common_ops,
 	.cable_detect		= pdc_pata_cable_detect,
 	.freeze			= pdc_freeze,
diff -urNp linux-2.6.32.24/drivers/ata/sata_qstor.c linux-2.6.32.24/drivers/ata/sata_qstor.c
--- linux-2.6.32.24/drivers/ata/sata_qstor.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_qstor.c	2010-09-04 15:54:52.000000000 -0400
@@ -132,7 +132,7 @@ static struct scsi_host_template qs_ata_
 	.dma_boundary		= QS_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations qs_ata_ops = {
+static const struct ata_port_operations qs_ata_ops = {
 	.inherits		= &ata_sff_port_ops,
 
 	.check_atapi_dma	= qs_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/sata_sil24.c linux-2.6.32.24/drivers/ata/sata_sil24.c
--- linux-2.6.32.24/drivers/ata/sata_sil24.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_sil24.c	2010-09-04 15:54:52.000000000 -0400
@@ -388,7 +388,7 @@ static struct scsi_host_template sil24_s
 	.dma_boundary		= ATA_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations sil24_ops = {
+static const struct ata_port_operations sil24_ops = {
 	.inherits		= &sata_pmp_port_ops,
 
 	.qc_defer		= sil24_qc_defer,
diff -urNp linux-2.6.32.24/drivers/ata/sata_sil.c linux-2.6.32.24/drivers/ata/sata_sil.c
--- linux-2.6.32.24/drivers/ata/sata_sil.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_sil.c	2010-09-04 15:54:52.000000000 -0400
@@ -182,7 +182,7 @@ static struct scsi_host_template sil_sht
 	.sg_tablesize		= ATA_MAX_PRD
 };
 
-static struct ata_port_operations sil_ops = {
+static const struct ata_port_operations sil_ops = {
 	.inherits		= &ata_bmdma32_port_ops,
 	.dev_config		= sil_dev_config,
 	.set_mode		= sil_set_mode,
diff -urNp linux-2.6.32.24/drivers/ata/sata_sis.c linux-2.6.32.24/drivers/ata/sata_sis.c
--- linux-2.6.32.24/drivers/ata/sata_sis.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_sis.c	2010-09-04 15:54:52.000000000 -0400
@@ -89,7 +89,7 @@ static struct scsi_host_template sis_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations sis_ops = {
+static const struct ata_port_operations sis_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.scr_read		= sis_scr_read,
 	.scr_write		= sis_scr_write,
diff -urNp linux-2.6.32.24/drivers/ata/sata_svw.c linux-2.6.32.24/drivers/ata/sata_svw.c
--- linux-2.6.32.24/drivers/ata/sata_svw.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_svw.c	2010-09-04 15:54:52.000000000 -0400
@@ -344,7 +344,7 @@ static struct scsi_host_template k2_sata
 };
 
 
-static struct ata_port_operations k2_sata_ops = {
+static const struct ata_port_operations k2_sata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.sff_tf_load		= k2_sata_tf_load,
 	.sff_tf_read		= k2_sata_tf_read,
diff -urNp linux-2.6.32.24/drivers/ata/sata_sx4.c linux-2.6.32.24/drivers/ata/sata_sx4.c
--- linux-2.6.32.24/drivers/ata/sata_sx4.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_sx4.c	2010-09-04 15:54:52.000000000 -0400
@@ -248,7 +248,7 @@ static struct scsi_host_template pdc_sat
 };
 
 /* TODO: inherit from base port_ops after converting to new EH */
-static struct ata_port_operations pdc_20621_ops = {
+static const struct ata_port_operations pdc_20621_ops = {
 	.inherits		= &ata_sff_port_ops,
 
 	.check_atapi_dma	= pdc_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/sata_uli.c linux-2.6.32.24/drivers/ata/sata_uli.c
--- linux-2.6.32.24/drivers/ata/sata_uli.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_uli.c	2010-09-04 15:54:52.000000000 -0400
@@ -79,7 +79,7 @@ static struct scsi_host_template uli_sht
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations uli_ops = {
+static const struct ata_port_operations uli_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.scr_read		= uli_scr_read,
 	.scr_write		= uli_scr_write,
diff -urNp linux-2.6.32.24/drivers/ata/sata_via.c linux-2.6.32.24/drivers/ata/sata_via.c
--- linux-2.6.32.24/drivers/ata/sata_via.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_via.c	2010-09-04 15:54:52.000000000 -0400
@@ -112,31 +112,31 @@ static struct scsi_host_template svia_sh
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations svia_base_ops = {
+static const struct ata_port_operations svia_base_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.sff_tf_load		= svia_tf_load,
 };
 
-static struct ata_port_operations vt6420_sata_ops = {
+static const struct ata_port_operations vt6420_sata_ops = {
 	.inherits		= &svia_base_ops,
 	.freeze			= svia_noop_freeze,
 	.prereset		= vt6420_prereset,
 };
 
-static struct ata_port_operations vt6421_pata_ops = {
+static const struct ata_port_operations vt6421_pata_ops = {
 	.inherits		= &svia_base_ops,
 	.cable_detect		= vt6421_pata_cable_detect,
 	.set_piomode		= vt6421_set_pio_mode,
 	.set_dmamode		= vt6421_set_dma_mode,
 };
 
-static struct ata_port_operations vt6421_sata_ops = {
+static const struct ata_port_operations vt6421_sata_ops = {
 	.inherits		= &svia_base_ops,
 	.scr_read		= svia_scr_read,
 	.scr_write		= svia_scr_write,
 };
 
-static struct ata_port_operations vt8251_ops = {
+static const struct ata_port_operations vt8251_ops = {
 	.inherits		= &svia_base_ops,
 	.hardreset		= sata_std_hardreset,
 	.scr_read		= vt8251_scr_read,
diff -urNp linux-2.6.32.24/drivers/ata/sata_vsc.c linux-2.6.32.24/drivers/ata/sata_vsc.c
--- linux-2.6.32.24/drivers/ata/sata_vsc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/sata_vsc.c	2010-09-04 15:54:52.000000000 -0400
@@ -306,7 +306,7 @@ static struct scsi_host_template vsc_sat
 };
 
 
-static struct ata_port_operations vsc_sata_ops = {
+static const struct ata_port_operations vsc_sata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	/* The IRQ handling is not quite standard SFF behaviour so we
 	   cannot use the default lost interrupt handler */
diff -urNp linux-2.6.32.24/drivers/atm/adummy.c linux-2.6.32.24/drivers/atm/adummy.c
--- linux-2.6.32.24/drivers/atm/adummy.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/atm/adummy.c	2010-09-04 15:54:52.000000000 -0400
@@ -77,7 +77,7 @@ adummy_send(struct atm_vcc *vcc, struct 
 		vcc->pop(vcc, skb);
 	else
 		dev_kfree_skb_any(skb);
-	atomic_inc(&vcc->stats->tx);
+	atomic_inc_unchecked(&vcc->stats->tx);
 
 	return 0;
 }
diff -urNp linux-2.6.32.24/drivers/atm/ambassador.c linux-2.6.32.24/drivers/atm/ambassador.c
--- linux-2.6.32.24/drivers/atm/ambassador.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/atm/ambassador.c	2010-09-04 15:54:52.000000000 -0400
@@ -453,7 +453,7 @@ static void tx_complete (amb_dev * dev, 
   PRINTD (DBG_FLOW|DBG_TX, "tx_complete %p %p", dev, tx);
   
   // VC layer stats
-  atomic_inc(&ATM_SKB(skb)->vcc->stats->tx);
+  atomic_inc_unchecked(&ATM_SKB(skb)->vcc->stats->tx);
   
   // free the descriptor
   kfree (tx_descr);
@@ -494,7 +494,7 @@ static void rx_complete (amb_dev * dev, 
 	  dump_skb ("<<<", vc, skb);
 	  
 	  // VC layer stats
-	  atomic_inc(&atm_vcc->stats->rx);
+	  atomic_inc_unchecked(&atm_vcc->stats->rx);
 	  __net_timestamp(skb);
 	  // end of our responsability
 	  atm_vcc->push (atm_vcc, skb);
@@ -509,7 +509,7 @@ static void rx_complete (amb_dev * dev, 
       } else {
       	PRINTK (KERN_INFO, "dropped over-size frame");
 	// should we count this?
-	atomic_inc(&atm_vcc->stats->rx_drop);
+	atomic_inc_unchecked(&atm_vcc->stats->rx_drop);
       }
       
     } else {
@@ -1341,7 +1341,7 @@ static int amb_send (struct atm_vcc * at
   }
   
   if (check_area (skb->data, skb->len)) {
-    atomic_inc(&atm_vcc->stats->tx_err);
+    atomic_inc_unchecked(&atm_vcc->stats->tx_err);
     return -ENOMEM; // ?
   }
   
diff -urNp linux-2.6.32.24/drivers/atm/atmtcp.c linux-2.6.32.24/drivers/atm/atmtcp.c
--- linux-2.6.32.24/drivers/atm/atmtcp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/atm/atmtcp.c	2010-09-04 15:54:52.000000000 -0400
@@ -206,7 +206,7 @@ static int atmtcp_v_send(struct atm_vcc 
 		if (vcc->pop) vcc->pop(vcc,skb);
 		else dev_kfree_skb(skb);
 		if (dev_data) return 0;
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -ENOLINK;
 	}
 	size = skb->len+sizeof(struct atmtcp_hdr);
@@ -214,7 +214,7 @@ static int atmtcp_v_send(struct atm_vcc 
 	if (!new_skb) {
 		if (vcc->pop) vcc->pop(vcc,skb);
 		else dev_kfree_skb(skb);
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		return -ENOBUFS;
 	}
 	hdr = (void *) skb_put(new_skb,sizeof(struct atmtcp_hdr));
@@ -225,8 +225,8 @@ static int atmtcp_v_send(struct atm_vcc 
 	if (vcc->pop) vcc->pop(vcc,skb);
 	else dev_kfree_skb(skb);
 	out_vcc->push(out_vcc,new_skb);
-	atomic_inc(&vcc->stats->tx);
-	atomic_inc(&out_vcc->stats->rx);
+	atomic_inc_unchecked(&vcc->stats->tx);
+	atomic_inc_unchecked(&out_vcc->stats->rx);
 	return 0;
 }
 
@@ -300,7 +300,7 @@ static int atmtcp_c_send(struct atm_vcc 
 	out_vcc = find_vcc(dev, ntohs(hdr->vpi), ntohs(hdr->vci));
 	read_unlock(&vcc_sklist_lock);
 	if (!out_vcc) {
-		atomic_inc(&vcc->stats->tx_err);
+		atomic_inc_unchecked(&vcc->stats->tx_err);
 		goto done;
 	}
 	skb_pull(skb,sizeof(struct atmtcp_hdr));
@@ -312,8 +312,8 @@ static int atmtcp_c_send(struct atm_vcc 
 	__net_timestamp(new_skb);
 	skb_copy_from_linear_data(skb, skb_put(new_skb, skb->len), skb->len);
 	out_vcc->push(out_vcc,new_skb);
-	atomic_inc(&vcc->stats->tx);
-	atomic_inc(&out_vcc->stats->rx);
+	atomic_inc_unchecked(&vcc->stats->tx);
+	atomic_inc_unchecked(&out_vcc->stats->rx);
 done:
 	if (vcc->pop) vcc->pop(vcc,skb);
 	else dev_kfree_skb(skb);
